-- Copyright (c) 2012 Cloudera, Inc. All rights reserved.
--
-- Version 33 of the CMF schema. Migration code to be applied on top of the
-- previous version.
--

update SCHEMA_VERSION set VERSION=33;

--
-- Add columns for configuring LDAP authentication
--
-- Modify columns of type
--     not null default ''
-- to make them consistent with Oracle as it treats empty string as null.
--

alter table SETTINGS
    add column LDAP_URL varchar(1024),
    add column NT_DOMAIN varchar(1024),
    add column LDAP_DN_PATTERN varchar(1024),
    modify column PASSWORD_HASH varchar(255) default null,
    modify column KEYSTORE_PATH longtext,
    modify column KEYSTORE_PASSWORD varchar(255) default null,
    modify column TRUSTSTORE_PATH longtext,
    modify column TRUSTSTORE_PASSWORD varchar(255) default null,
    modify column LICENSE_KEY text;
